#!/usr/bin/perl

####################################
#
# SDPMailingList Version 1.2
# Copyright 1999
# Michael B. Jones
# http://www.shindigproductions.com
#
####################################
#
# COPYRIGHT NOTICE
# Copyright 1999 Shindig Productions
# All Rights Reserved
#
# This script can be used/modified free of charge as long as this header
# remains intact.  The script is presented "as-is" without any
# warranty, and the author is not liable for any loss or damages arising
# out of the use of or failure to use this script.  Redistributing/selling
# the code for this program without prior written consent is expressly forbidden.
#
####################################

require "SDPMList.cfg";

##########
# Globals

$product = "SDPMailingList v.1.1";
$sdp_url = "http://wml.webservis.ru";
$copyright = "1999";

#############
# Parse form
    
   if ($ENV{'REQUEST_METHOD'} eq 'GET') {
       &error('request');
       exit;
   }

   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/<!--(.|\n)*-->//g;
      $value =~ s/<([^>]|\n)*>//g;
      $FORM{$name} = $value;
   }

##############
# Subroutines

if (($FORM{'action'} ne "subscribe") && ($FORM{'action'} ne "unsubscribe")) {
&error('no_action');
exit;
}
&assign;
&check_email;
if ($FORM{'action'} eq "subscribe") {
&subscribe;
}
if ($FORM{'action'} eq "unsubscribe") {
&unsubscribe;
}
if ($mail == 1) {
&sendmail;
}
exit;

###################
# Assign Variables

sub assign {

   if ($FORM{'email'}) {
      $email = "$FORM{'email'}";
      $email =~ s/"//g;
      $email =~ s/<//g;
      $email =~ s/>//g;
      $email =~ s/\&//g;
   }

   if ($FORM{'action'}) {
      $action = "$FORM{'action'}";
   }
}

#######################
# Check e-mail address

sub check_email {

   unless ($email =~/.*\@.*\..*/) { 
       &error('bad_email');
       exit;
   }
}

############
# Subscribe

sub subscribe {

    open(LIST,"$basedir/$mailfile") || die $!;
    @list = <LIST>;
    foreach $line (@list) {
        if ($line =~ /$email/i) {
            &error('dupe_email');
            exit;
        }
    }
    close(LIST);

    open(LIST,">$basedir/$mailfile") || die $!;
    foreach $line (@list) {
        if ($line =~ /<!--update-->/) {
            print LIST "<!--update-->\n";
            print LIST "$email\n";
        }
        else {
            print LIST "$line";
        }
    }
    close(LIST);
    print <<"END HTML";
Content-type: text/html

<html>
<head>
<title>Success: $email Subscribed</title>
</head>
<$body>
<center><br><br>
<table border=0 width=70%>
<tr><td bgcolor="#ff0000">
<$title_font>Success: $email Subscribed</font>
</td></tr>
<tr><td bgcolor="#0000ff">
<$text_font>
$sub_response
<br><br>
<center>Copyright &copy;$copyright <a href="$sdp_url">Shindig Productions</a>
</font></center>
</td></tr>
</table>
</center>
</body>
</html>
END HTML
}

##############
# Unsubscribe

sub unsubscribe {

    open(LIST,"<$basedir/$mailfile") || die $!;
    @list = <LIST>;
    close(LIST);
    $count = 0;
    foreach $list(@list) {
        $count++;
        if ($list =~ /$email/i) {
            $count--;
            splice(@list, $count, 1);
            open(UNSUB, ">$basedir/$mailfile") || die $!;
            print UNSUB @list;
            close(UNSUB);

    print <<"END HTML";
Content-type: text/html

<html>
<head>
<title>Success: $email Unsubscribed</title>
</head>
<$body>
<center><br><br>
<table border=0 width=70%>
<tr><td bgcolor="#ff0000">
<$title_font>Success: $email Unsubscribed</font>
</td></tr>
<tr><td bgcolor="#0000ff">
<$text_font>
$unsub_response
<br><br>
<center>Copyright &copy;$copyright <a href="$sdp_url">Shindig Productions</a>
</font></center>
</td></tr>
</table>
</center>
</body>
</html>
END HTML
exit;
        }
    }
    &error('no_email');
    exit;
}

###################
# Send mail option

sub sendmail {

        open(MAIL,"|$mailprog -t") || die $!;
        print MAIL "To: $email\n";
        print MAIL "From: $product\n";
        if ($action eq 'subscribe') {
            print MAIL "Subject: Thank You for Subscribing\n";
            print MAIL "$sub_response\n\n";
        }
        else {
            print MAIL "Subject: You Have Successfully Unsubscribed\n";
            print MAIL "$unsub_response\n\n";
        }
        print MAIL "This mail was processed by $product\n";
        print MAIL "Available for free at $sdp_url";
        close (MAIL);
}

##########
# Errors

sub error { 

    $error = $_[0];
    if ($error eq 'no_action') {
        print "Content-type: text/html\n\n";    
        print <<"END HTML";
<html>
<head>
<title>Error: No Action Selected</title>
</head>
<$body>
<center><br><br>
<table border=0 width=70%>
<tr><td bgcolor="#ff0000">
<$title_font>
Error: No Action Selected</font>
</td></tr>
<tr><td bgcolor="#0000f">
<$text_font>
You must select an action of either Subscribe or Unsubscribe. Please use your browser\'s Back button to do so.
<br><br>
<center>Copyright &copy;$copyright <a href="$sdp_url">Shindig Productions</a>
</font></center>
</td></tr>
</table>
</center>
</body>
</html>
END HTML
    }
        elsif ($error eq 'bad_email') {
        print <<"END HTML";
Content-type: text/html

<html>
<head>
<title>Error: Bad E-mail</title>
</head>
<$body>
<center><br><br>
<table border=0 width=70%>
<tr><td bgcolor="#ff0000">
<$title_font>
Error: Bad E-mail</font>
</td></tr>
<tr><td bgcolor="#0000f">
<$text_font>
The e-mail address you entered does not match a valid format. Please use your browser\'s
Back button and re-enter your e-mail address.
<br><br>
<center>Copyright &copy;$copyright <a href="$sdp_url">Shindig Productions</a>
</font></center>
</td></tr>
</table>
</center>
</body>
</html>
END HTML
    }
        elsif ($error eq 'request') {
        print <<"END HTML";
Content-type: text/html

<html>
<head>
<title>$product</title>
</head>
<$body>
<br><br>
<center><table border=0 width=70%>
<tr> 
<td bgcolor="#ff0000">
<center>
<$title_font>$product
</font></center>
</td></tr>
<tr><td bgcolor="#0000ff"> 
<center>
<$text_font>Copyright &copy;$copyright <a href="$sdp_url">Shindig Productions</a></font> 
</center>
</td></tr>
</table></center>
</body>
</html>
END HTML
    }
        elsif ($error eq 'dupe_email') {
        print <<"END HTML";
Content-type: text/html

<html>
<head>
<title>Error: Duplicate E-mail</title>
</head>
<$body>
<center><br><br>
<table border=0 width=70%>
<tr><td bgcolor="#ff0000">
<$title_font>Error: Duplicate E-mail Address</font>
</td></tr>
<tr><td bgcolor="#0000ff">
<$text_font>
The E-mail address you entered ($email) is already in the database.
<br><br>
<center>Copyright &copy;$copyright <a href="$sdp_url">Shindig Productions</a>
</font></center>
</td></tr>
</table>
</center>
</body>
</html>
END HTML
    }
        elsif ($error eq 'no_email') {
        print <<"END HTML";
Content-type: text/html

<html>
<head>
<title>Error: E-mail Address Not Found</title>
</head>
<$body>
<center><br><br>
<table border=0 width=70%>
<tr><td bgcolor="#ff0000">
<$title_font>Error: E-mail Address Not Found</font>
</td></tr>
<tr><td bgcolor="#0000ff">
<$text_font>
The E-mail address you entered ($email) was not found in the database.
<br><br>
<center>Copyright &copy;$copyright <a href="$sdp_url">Shindig Productions</a>
</font></center>
</td></tr>
</table>
</center>
</body>
</html>
END HTML
    }
}